/*
 *    
 */
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <unistd.h>
#include <stdlib.h>

#include "strutils.h"

#define MAXLEN 256

char path[MAXLEN];

void ReadHTMLWord(FILE *F, char *buf) {
  char c;
  char *p;
  while (!feof(F)) {
    if (fread(&c,1,1,F)<=0) break;
    if (c=='<') {
      p=buf;
      *buf++=c;
      while (!feof(F) && c!='>') {
        if (fread(&c,1,1,F)<=0) break;
        *buf++=c;
      }
      if (strncmp(p,"<a ",3)==0) break;
      if (strncmp(p,"</a",3)==0) break;
      if (strncmp(p,"<dl",3)==0) break;
      if (strncmp(p,"</dl",3)==0) break;
    }
    else if (c==' ' || c=='\n' || c==0)
      break;
    else
      *buf++=c;
  }
  *buf++=0;
} //ReadHTMLWord

void putind(FILE *F, char *w) {
  int i;
  for (i=0; i<strlen(w); i++) {
    fprintf(F,"%02x",(unsigned char)w[i]);
  }
} //putind

void getind(char **h, char *w) {
  char buf[3];
  char *p;
  unsigned c;

  while (**h && **h!=' ') {
    p=buf;
    *p++=*(*h)++;
    *p++=*(*h)++;
    *p=0;
    sscanf(buf,"%02x",&c);
    *w++=c;
  }
  *w=0;
  while (**h==' ') (*h)++;
} //getind

int curmode=0;
int wmode=-1;
char *begword,*endword;

char *getword(char **s) {
  static char buf[MAXLEN];
  register char *p,*pp;//*begword,*endword;

  wmode=-1;
  p=buf; begword=endword=*s;
  while (**s) {
    if (strncmp(*s,"<i>",3)==0)
      curmode|=1;
    else if (strncmp(*s,"</i>",4)==0)
      curmode&=~1;
    else if (strncmp(*s,"<dt>",4)==0)
      curmode|=2;
    else if (strncmp(*s,"</dt>",5)==0)
      curmode&=~2;
    else if (strncmp(*s,"<small>",7)==0)
      curmode|=4;
    else if (strncmp(*s,"</small>",8)==0)
      curmode&=~4;

    if (strncmp(*s,"<span ",6)==0 || strncmp(*s,"</span>",7)==0) {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      while (**s && **s!='>')
        (*s)++;
      if (**s=='>') (*s)++;
      endword=*s;
    }
    else if (**s=='<' && strncmp(*s,"<em>",4) && strncmp(*s,"</em>",5)) {
      while (**s && **s!='>')
        (*s)++;
      if (**s=='>') (*s)++;
      break;
    }
    else if (**s==' ' || **s=='\n' ||
        **s=='.' || **s==',' || **s==';' || **s==':' ||
        **s=='=' || **s=='!' || **s=='?') {
      (*s)++;
      break;
    }
    else if (**s=='&') {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      while (**s && **s!=';')
        *p++=*(*s)++;
      *p++=*(*s)++;
      endword=*s;
    }
    else {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      *p++=*(*s)++;
      endword=*s;
    }
  }
  *p=0;
  uni_decode(buf);

  while (rep(buf,"<em>", ""));
  while (rep(buf,"</em>", ""));
  while (rep(buf,"&#8211;", ""));
  while (rep(buf,"&#183;", ""));
  while (rep(buf,"&#769;", ""));
  while (rep(buf,"*", ""));
  while (rep(buf,"-", ""));
  while (rep(buf,"=", ""));
  while (rep(buf,"&mdash;", ""));
  while (rep(buf,"&ndash;", ""));
  while (rep(buf,"&laquo;", ""));
  while (rep(buf,"&raquo;", ""));
  while (rep(buf,"&gt;", ""));
  while (rep(buf,"&lt;", ""));
  while (rep(buf,"<span class=\"rad\">", ""));
  while (rep(buf,"</span>", ""));
  while (rep(buf,"\"", ""));
  while (rep(buf,"\'", ""));
  while (rep(buf,"0", ""));
  while (rep(buf,"1", ""));
  while (rep(buf,"2", ""));
  while (rep(buf,"3", ""));
  while (rep(buf,"4", ""));
  while (rep(buf,"5", ""));
  while (rep(buf,"6", ""));
  while (rep(buf,"7", ""));
  while (rep(buf,"8", ""));
  while (rep(buf,"9", ""));
  while (rep(buf,"/", ""));
  while (rep(buf,"+i", ""));
  while (rep(buf,"\r", ""));

  if (strcmp(buf,"I")==0) buf[0]=0;
  if (strcmp(buf,"II")==0) buf[0]=0;

  //neparaj krampoj
  if (strchr(buf,'(') && !strchr(buf,')')) {
    if (buf[0]=='(') begword++;
    rep(buf,"(","");
  }
  if (strchr(buf,')') && !strchr(buf,'(')) {
    if (buf[strlen(buf)-1]==')') endword--;
    rep(buf,")","");
  }
  if (buf[0]=='(' && buf[strlen(buf)-1]==')') {
    del(buf,1);
    buf[strlen(buf)-1]=0;
    begword++; endword--;
  }

  //kadrantaj citiloj
  if (strncmp(begword,"&laquo;",7)==0)
    begword+=7;
  if (strncmp(endword-7,"&raquo;",7)==0)
    endword-=7;

  toLower(buf);
  /*if (buf[0]) {
    ins(endword,"}}");
    ins(begword,"{{");
    (*s)+=strlen("{{")+strlen("}}");
  } //if*/
  return buf;
} //getword

int Max=0;
void load(char *fname, FILE *out) {
 char name[MAXLEN];
 char buf[MAXLEN];
 char w1[MAXLEN],w2[MAXLEN];
 long pos,npos;
 FILE *F;
 char *p,*w;
 int m;

 strcpy(name,fname);
 p=strstr(name,".html");
 if (*p) *p=0;

 fprintf(stderr,"%s ",name);

 sprintf(buf,"%s%s",path,fname);
 F=fopen(buf,"r");
 pos=0;

 while (!feof(F)) {
   npos=ftell(F);
   ReadHTMLWord(F,buf);
   if (strlen(buf)>Max) Max=strlen(buf);

   if (strstr(buf,"<dl>"))
     pos=npos;
   if (pos==0) continue;

   p=buf;
   while (*p) {
     w=getword(&p);
     if (*w==0) continue;

     if ((wmode&1) && (wmode&4)) m=5; //ke
     else if (wmode&2) m=1; //v
     else if (wmode&1) m=3; //k
     else if (wmode&4) m=4; //e
     else if (wmode==0) m=2; //t
     else m=0;

     if (m>2) {
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
       if (strcmp(w,"")==0) continue;
     }
     if (checkbrc(w,w1,w2)) {
       putind(out,w);
       fprintf(out," %d%s%06ld\r\n",m,name,pos);
       //fprintf(out," %s %d%s%d\r\n",w,m,name,pos);
     }
     else {
       putind(out,w1);
       fprintf(out," %d%s%06ld\r\n",m,name,pos);
       //fprintf(out," %s %d%s%d\r\n",w1,m,name,pos);
       putind(out,w2);
       fprintf(out," %d%s%06ld\r\n",m,name,pos);
       //fprintf(out," %s %d%s%d\r\n",w2,m,name,pos);
     }
   }
   if (strstr(buf,"</dl>"))
     pos=0;
 }
 fclose(F);
} //load

void glue(FILE *in,FILE *out) {
  char buf[MAXLEN], w[MAXLEN], oldw[MAXLEN], pos[MAXLEN], oldpos[MAXLEN];
  char w0[MAXLEN];
  char *p,*pp;

  oldw[0]=0; oldpos[0]=0;
  while (!feof(in)) {
    fgets(buf,sizeof(buf)-1,in);
    p=buf;

    getind(&p,w);

    if (strcmp(w,oldw)==0) {
      pp=pos;
      while (*p && *p!='\n' && *p!='\r' && *p!=' ')
        *pp++=*p++; //fprintf(out,"%c",*p++);
      *pp=0;
      if (strcmp(pos,oldpos))
        fprintf(out," %s",pos);
      strcpy(oldpos,pos);
    }
    else {
      if (oldw[0])
        fprintf(out,"\r\n");
      fprintf(out,"%s ",w);
      pp=pos;
      while (*p && *p!='\n' && *p!='\r' && *p!=' ')
        *pp++=*p++; //fprintf(out,"%c",*p++);
      *pp=0;
      fprintf(out,"%s",pos);
      strcpy(oldw,w);
      strcpy(oldpos,pos);
    } //if
  } //while
} //glue

int main(int argc, char **argv) {
  FILE *in,*out;
  struct dirent *d;
  DIR *dirp;
  char buf[MAXLEN*3];

  if (argc>1)
    strcpy(path,argv[1]);
  if (path[0] && path[strlen(path)]!='/')
    strcat(path,"/");

  fprintf(stderr,"   *** Kreado de sercxindekso ***\n");

  sprintf(buf,"%sindex.1",path);
  out=fopen(buf,"wb");

  sprintf(buf,"%s.",path);
  dirp=opendir(buf);
  while (d=readdir(dirp)) {
    if (strstr(d->d_name,".html")==0) continue;
    if (strstr(d->d_name,"i_")) continue;
    if (strstr(d->d_name,"antau")) continue;
    if (strstr(d->d_name,"gramat")) continue;
    if (strstr(d->d_name,"index")) continue;
    if (strstr(d->d_name,"EoRu")) continue;
    if (strstr(d->d_name,"kovril")) continue;
    if (strstr(d->d_name,"elsxut")) continue;
    load(d->d_name,out);
  }
  closedir(dirp);
  fclose(out);
  fprintf(stderr,"\nOrdigo...\n");

  sprintf(buf,"sort %sindex.1 >%sindex.2",path,path);
  system(buf);

  sprintf(buf,"%sindex.1",path);
  unlink(buf);

  fprintf(stderr,"Kunigo...\n");
  sprintf(buf,"%sindex.2",path);
  in=fopen(buf,"r");
  sprintf(buf,"%sindex.ind",path);
  out=fopen(buf,"wb");
  glue(in,out);
  fclose(in);
  fprintf(out,"\r\n");
  fclose(out);

  sprintf(buf,"%sindex.2",path);
  unlink(buf);
  fprintf(stderr,"Farite!\n");
  return 0;
}
